angular.module('ferrizlivetv', ['ionic', 'ngCordova', 'ferrizlivetv.controllers', 'ferrizlivetv.services'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    if(typeof analytics !== "undefined") {
      analytics.startTrackerWithId("UA-43004432-2");
      analytics.debugMode();
    } else {
      console.log("Google Analytics Unavailable");
      /*analytics = {
        trackView:function(v){ console.log("track",v); },
        trackEvent:function(a,b,c){console.log("track",a,b,c); }
      };*/
    }
  });
})

.directive('a', function () {
    return {
        restrict: 'E',
        link: function (scope, element, attrs) {
            if ( !attrs.href ){
                return;
            }
            var externalRe = new RegExp("^(http|https)://");
            var url = attrs.href;

            if(externalRe.test(url)) {
                element.on('click',function(e){
                    e.preventDefault();
                    if(attrs.ngClick){
                        scope.$eval(attrs.ngClick);
                    }
                    window.open(encodeURI(url), '_system');
                });
            }
        }
    };
})

.config(function($ionicConfigProvider) {
  $ionicConfigProvider.tabs.position("bottom");
  $ionicConfigProvider.tabs.style("standard");
})
.config(function($sceDelegateProvider) {
 $sceDelegateProvider.resourceUrlWhitelist([
   // Allow same origin resource loads.
   'self',
   'http://www.youtube.com/**']);
 })
.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider

  // setup an abstract state for the tabs directive
  .state('tab', {
    url: "/tab",
    abstract: true,
    templateUrl: "templates/tabs.html"
  })
  // Each tab has its own nav history stack:
  .state('tab.videos', {
    url: '/videos',
    views: {
      'tab-videos': {
        templateUrl: 'templates/tab-videos.html',
        controller: 'VideosCtrl'
      }
    }
  })
  .state('tab.videos-detail', {
    url: '/videos/:videoId',
    views: {
      'tab-videos': {
        templateUrl: 'templates/video-detail.html',
        controller: 'VideosDetailCtrl'
      }
    }
  })
  .state('tab.noticias', {
    url: '/noticias',
    views: {
      'tab-noticias': {
        templateUrl: 'templates/tab-noticias.html',
        controller: 'NoticiasCtrl'
      }
    }
  })
  .state('tab.favs', {
    url: '/favs',
    views: {
      'tab-favs': {
        templateUrl: 'templates/tab-favs.html',
        controller: 'FavsCtrl'
      }
    }
  })
  .state('tab.favs-detail', {
    url: '/favs/videos/:videoId',
    views: {
      'tab-favs': {
        templateUrl: 'templates/video-detail.html',
        controller: 'VideosDetailCtrl'
      }
    }
  })
  .state('tab.favs-noticias', {
    url: '/favs/noticias',
    views: {
      'tab-favs': {
        templateUrl: 'templates/tab-favs-noticias.html',
        controller: 'FavsNoticiasCtrl'
      }
    }
  })
  .state('tab.radio', {
    url: '/radio',
    views: {
      'tab-radio': {
        templateUrl: 'templates/tab-radio.html',
        controller: 'RadioCtrl'
      }
    }
  });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/videos');

});
