angular.module('ferrizlivetv.controllers', ['ngCordova'])

.controller('RadioCtrl', function($scope) {
  $scope.$on('$ionicView.enter', function() {
    if(typeof analytics !== "undefined") {
      analytics.trackView("Radio");
    }
  });
})

.controller('VideosCtrl', function($scope, $cordovaSocialSharing, Videos, Banner, $ionicLoading) {
  $scope.videos = Videos.getAll();
  $scope.banner = Banner.getBanner();
  Banner.update(function(banner){
    $scope.banner = banner;
  });
  $scope.toggleFav = function(video) {
    Videos.toggleFav(video);
    if(typeof analytics !== "undefined") {
      analytics.trackEvent("Videos", video.faved ? "Favorite" : "Unfavorite", video.title);
    }
  };
  $scope.share = function(video) {
    $cordovaSocialSharing.share(video.title, "Te recomiendo este vídeo.", video.img, video.url);
    if(typeof analytics !== "undefined") {
      analytics.trackEvent("Videos", "Share", video.title);
    }
  };
  $scope.bannerclick = function(href, title){
    if(href){
      window.open(href,"_system");
      if(typeof analytics !== "undefined") {
        analytics.trackEvent("Videos", "Banner Click", title);
      }
    }
  };
  $scope.doRefresh = function() {
    Videos.update(function(){
      $scope.$broadcast('scroll.refreshComplete');
    });
  };
  $scope.update = function() {
    $ionicLoading.show({
      template: 'Actualizando Vídeos'
    });
    Videos.update(function(){
       $ionicLoading.hide();
    });
  };
  $scope.update();
  $scope.loadMore = function() {
    Videos.more(function(){
      $scope.$broadcast('scroll.infiniteScrollComplete');
      if(typeof analytics !== "undefined") {
        analytics.trackEvent("Videos", "Load More", Videos.current_page);
      }
    });
  };
  $scope.moreDataCanBeLoaded = function() {
    return Videos.canUpdate;
  };
  $scope.$on('$ionicView.enter', function() {
    if(typeof analytics !== "undefined") {
      analytics.trackView("Videos");
    }
  });
})

.controller('VideosDetailCtrl', function($scope, $stateParams, Videos) {
  var v = Videos.get($stateParams.videoId);
  $scope.url = v.vurl;
  $scope.title = v.title;
  if(typeof analytics !== "undefined") {
    analytics.trackEvent("Videos", "View", v.title);
  }
})

.controller('NoticiasCtrl', function($scope, $cordovaSocialSharing, Noticias, Banner, $ionicLoading) {
  $scope.noticias = Noticias.getAll();
  $scope.banner = Banner.getBanner();
  Banner.update(function(banner){
    $scope.banner = banner;
  });
  $scope.share = function(noticia) {
    $cordovaSocialSharing.share(noticia.title, "Te recomiendo esta noticia.", noticia.img, noticia.url);
    if(typeof analytics !== "undefined") {
      analytics.trackEvent("Noticias", "Share", noticia.title);
    }
  };
  $scope.bannerclick = function(href, title){
    if(href){
      window.open(href,"_system");
      if(typeof analytics !== "undefined") {
        analytics.trackEvent("Noticias", "Banner Click", title);
      }
    }
  };
  $scope.newbrowser = function(href, title){
    if(href){
      window.open(href,"_system");
      if(typeof analytics !== "undefined") {
        analytics.trackEvent("Noticias", "View", title);
      }
    }
  };
  $scope.toggleFav = function(noticia) {
    Noticias.toggleFav(noticia);
    if(typeof analytics !== "undefined") {
      analytics.trackEvent("Noticias", noticia.faved ? "Favorite" : "Unfavorite", noticia.title);
    }
  };
  $scope.doRefresh = function() {
    Noticias.update(function(){
      $scope.$broadcast('scroll.refreshComplete');
    });
  };
  $scope.update = function() {
    $ionicLoading.show({
      template: 'Actualizando Noticias'
    });
    Noticias.update(function(){
       $ionicLoading.hide();
    });
  };
  $scope.update();
  $scope.loadMore = function() {
    Noticias.more(function(){
      $scope.$broadcast('scroll.infiniteScrollComplete');
      if(typeof analytics !== "undefined") {
        analytics.trackEvent("Noticias", "Load More", Noticias.current_page);
      }
    });
  };
  $scope.moreDataCanBeLoaded = function() {
    return Noticias.canUpdate;
  };
  $scope.$on('$ionicView.enter', function() {
    if(typeof analytics !== "undefined") {
      analytics.trackView("Noticias");
    }
  });
})
.controller('FavsCtrl', function($scope, Videos) {
  $scope.videos = Videos.getAllFav();
  $scope.toggleFav = function(video) {
    Videos.toggleFav(video);
    if(typeof analytics !== "undefined") {
      analytics.trackEvent("Videos-Favoritos", video.faved ? "Favorite" : "Unfavorite", video.title);
    }
  };
  $scope.share = function(video) {
    $cordovaSocialSharing.share(video.title, 'Te recomiendo este vídeo.', video.img, video.url);
    if(typeof analytics !== "undefined") {
      analytics.trackEvent("Videos-Favoritos", "Share", video.title);
    }
  };
  $scope.$on('$ionicView.enter', function() {
    if(typeof analytics !== "undefined") {
      analytics.trackView("Videos-Favoritos");
    }
  });
})
.controller('FavsNoticiasCtrl', function($scope, Noticias) {
  $scope.noticias = Noticias.getAllFav();
  $scope.toggleFav = function(noticia) {
    Noticias.toggleFav(noticia);
    if(typeof analytics !== "undefined") {
      analytics.trackEvent("Noticias-Favoritos", noticia.faved ? "Favorite" : "Unfavorite", noticia.title);
    }
  };
  $scope.newbrowser = function(href, title){
    if(href){
      window.open(href,"_system");
      if(typeof analytics !== "undefined") {
        analytics.trackEvent("Noticias-Favoritos", "View", title);
      }
    }
  };
  $scope.share = function(noticia) {
    $cordovaSocialSharing.share(noticia.title, "Te recomiendo esta noticia.", noticia.img, noticia.url);
    if(typeof analytics !== "undefined") {
      analytics.trackEvent("Noticias-Favoritos", "Share", noticia.title);
    }
  };
  $scope.$on('$ionicView.enter', function() {
    if(typeof analytics !== "undefined") {
      analytics.trackView("Noticias-Favoritos");
    }
  });
})
;
