angular.module('ferrizlivetv.services', [])

.factory('$localstorage', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function(key) {
      return JSON.parse($window.localStorage[key] || '{}');
    }
  };
}])


.factory('Elementos', function($http, $localstorage){

  var Elementos = function(){
    this.local_elementos_var = "elementos";
    this.count_request = 10;
    this.count_request_init = 20;
    this.service = "http://services.com/?count=%%COUNT%%&page=%%PAGE%%";
    this.data_count_var = "count";
    this.data_elements_var = "posts";
    this.data_elements_id_var = "id";
    this.data_elements_cast = ["id","title","date"];
    this.data_elements_orderby = "date";
    this.data_elements_decode_htmlentities = ["title"];
    this.elementos = [];
    this.elementos_favoritos = [];
    this.canUpdate = true;
    this.current_page = 1;
  };

  Elementos.prototype.toggleFav = function(elemento){
    var eindex = this.indexOf(elemento[this.data_elements_id_var]);
    var findex = this.indexOfFav(elemento[this.data_elements_id_var]);
    if(findex >= 0){
      elemento.faved = false;
      this.elementos_favoritos.splice(findex, 1);
      if(eindex >= 0){
        this.elementos[eindex].faved = false;
      }
    }
    else{
      if(eindex >= 0){
        elemento.faved = true;
        this.elementos_favoritos.push(this.elementos[eindex]);
        this.elementos[eindex].faved = true;
      }
    }
    var $this = this;
    this.elementos_favoritos.sort(function(a,b){ return new Date(b[$this.data_elements_orderby]) - new Date(a[$this.data_elements_orderby]); });
    this.saveLocal();
  };
  Elementos.prototype.indexOf = function(elementoId){
    for(var i = 0, l = this.elementos.length; i < l; i++){
      if(parseInt(this.elementos[i][this.data_elements_id_var]) == parseInt(elementoId)){
        return i;
      }
    }
    return -1;
  };
  Elementos.prototype.indexOfFav = function(elementoId){
    for(var i = 0, l = this.elementos_favoritos.length; i < l; i++){
      if(parseInt(this.elementos_favoritos[i][this.data_elements_id_var]) == parseInt(elementoId)){
        return i;
      }
    }
    return -1;
  };
  Elementos.prototype.initLocal = function(){
    var local_elementos = $localstorage.getObject(this.local_elementos_var);
    if(this.elementos.length === 0 && local_elementos.length){
      this.elementos = local_elementos;
    }
    var local_favs = $localstorage.getObject(this.local_elementos_var + "_fav");
    if(this.elementos_favoritos.length === 0 && local_favs.length){
      this.elementos_favoritos = local_favs;
    }
  };
  Elementos.prototype.saveLocal = function(){
    $localstorage.setObject(this.local_elementos_var, this.elementos.slice(0,20));
    $localstorage.setObject(this.local_elementos_var + "_fav", this.elementos_favoritos);
  };
  Elementos.prototype.get = function(elementoId){
    var aux = this.getById(elementoId);
    if(aux){
      return aux;
    }
    return this.getFavById(elementoId);
  };
  Elementos.prototype.getById = function(elementoId){
    this.initLocal();
    var index = this.indexOf(elementoId);
    if(index >= 0){
      return this.elementos[index];
    }
    return false;
  };
  Elementos.prototype.getFavById = function(elementoId){
    this.initLocal();
    var index = this.indexOfFav(elementoId);
    if(index >= 0){
      return this.elementos_favoritos[index];
    }
    return false;
  };
  Elementos.prototype.getAllFav = function(){
    this.initLocal();
    return this.elementos_favoritos;
  };
  Elementos.prototype.getAll = function(){
    this.initLocal();
    return this.elementos;
  };
  Elementos.prototype.update = function(succescb){
    this.initLocal();
    this.request(this.count_request_init,1,succescb);
  };
  Elementos.prototype.more = function(succescb){
    this.initLocal();
    this.request(this.count_request,Math.floor(this.elementos.length/this.count_request + 1),succescb);
  };
  Elementos.prototype.elementCast = function(element, original_element)
  {
    return element;
  };
  Elementos.prototype.dataCast = function(data)
  {
    var $this = this,
        _elementos = data[this.data_elements_var],
        id = this.data_elements_id_var,
        xe = document.createElement('div'),
        cast = this.data_elements_cast;
    for (var i = 0, w = -1, e; i < _elementos.length; i++)
    {
      w = this.indexOf(_elementos[i][id]);
      e = w < 0 ? {} : this.elementos[w];
      //Filter Props
      var prop;
      for(prop in cast)
        e[cast[prop]] = _elementos[i][cast[prop]];
      //Clean Title
      if(this.data_elements_decode_htmlentities.length){
        for(prop in this.data_elements_decode_htmlentities)
        {
          xe.innerHTML = e[this.data_elements_decode_htmlentities[prop]];
          e[this.data_elements_decode_htmlentities[prop]] = xe.textContent;
        }
      }
      e = this.elementCast(e,_elementos[i]);
      //Utils
      e.faved = this.indexOfFav(e[id]) >= 0;
      if(w < 0)
        this.elementos.push(e);
    }
    //Order
    this.elementos.sort(function(a,b)
    {
      var ad = a[$this.data_elements_orderby].split(/[- :]/), bd = b[$this.data_elements_orderby].split(/[- :]/);
      ad = new Date(ad[0], ad[1]-1, ad[2], ad[3], ad[4], ad[5]);
      bd = new Date(bd[0], bd[1]-1, bd[2], bd[3], bd[4], bd[5]);
      return bd - ad;
    });

    xe.textContent = '';
  };
  Elementos.prototype.request = function(count,page,succescb)
  {
    this.current_page = page;
    var $this = this, nocache = "", current_date = new Date(), cache_date = new Date(parseInt($localstorage.get(this.local_elementos_var + "cache_date",0)));
    if(current_date.getTime() - (1000 * 60 * 60 * 24 * 1.5) > cache_date.getTime())
    {
      nocache = "&nocache=" + current_date.getTime();
      $localstorage.set(this.local_elementos_var + "cache_date", current_date.getTime());
    }
    $http({
      method:'GET',
      url:this.service.replace("%%COUNT%%",count).replace("%%PAGE%%",page) + nocache
    })
    .success(function(data)
    {
      $this.dataCast(data);
      $this.saveLocal();
      $this.canUpdate = parseInt(data[$this.data_count_var]) >= 10;
      succescb();
    })
    .error(function(data, status, headers, config){
      $this.canUpdate = false;
      succescb();
    });
  };

  return Elementos;
})

.factory('Videos', function(Elementos){

  var Videos = function() {
    Elementos.apply(this, arguments);
    this.local_elementos_var = "videos";
    this.service = "http://ferriz.com.mx/?json=get_posts&ignore_sticky_posts=0&count=%%COUNT%%&page=%%PAGE%%&post_type=post&meta_key=iframe&status=publish&cat=%2753,37645%27";
    this.data_elements_cast = ["id","type","slug","url","title","date","modified"];
  };
  Videos.prototype = new Elementos();
  Videos.prototype.elementCast = function(e, oe)
  {
    //Youtube Thumbs
    e.yid = false;
    e.img = "img/default.jpg";

    try{
      var match = oe.custom_fields.iframe[0].match(/^.*((youtu.be\/)|(v\/)|(\/u\/\w\/)|(embed\/)|(watch\??v?=?))([^#\&\?]*).*/);
      if (match && match[7].length == 11){
        e.yid = match[7];
        e.yimg = {
          default:        "http://img.youtube.com/vi/"+e.yid+"/default.jpg",
          hqdefault:     "http://img.youtube.com/vi/"+e.yid+"/hqdefault.jpg"
          //mqdefault:     "http://img.youtube.com/vi/"+e.yid+"/mqdefault.jpg"
          //sddefault:     "http://img.youtube.com/vi/"+e.yid+"/sddefault.jpg"
          //maxresdefault: "http://img.youtube.com/vi/"+e.yid+"/maxresdefault.jpg"
          //1:             "http://img.youtube.com/vi/"+e.yid+"/1.jpg"
          //2:             "http://img.youtube.com/vi/"+e.yid+"/2.jpg"
          //3:             "http://img.youtube.com/vi/"+e.yid+"/3.jpg"
        };
        e.vurl = "http://www.youtube.com/embed/" + e.yid + "?vq=small";
        e.img = e.yimg.hqdefault;
      }
      else{
        e.vurl = oe.custom_fields.iframe[0];
        e.img = oe.attachments[0].url;
      }
    }catch(exception){}
    return e;
  };
  return new Videos();
})

.factory('Noticias', function(Elementos){

  var Noticias = function() {
    Elementos.apply(this, arguments);
    this.local_elementos_var = "noticias";
    this.service = "http://ferriz.com.mx/?json=get_posts&ignore_sticky_posts=0&count=%%COUNT%%&page=%%PAGE%%&post_type=post&status=publish&cat=%2740,41,42,43,44,48,338,617,892,3057,4333,20992%27";
    this.data_elements_cast = ["id","type","slug","url","title","excerpt","date","modified"];
    this.data_elements_decode_htmlentities = ["title","excerpt"];
  };
  Noticias.prototype = new Elementos();
  Noticias.prototype.elementCast = function(e, oe)
  {
    e.img = "img/default.jpg";
    try{
      e.img = (oe.attachments[0] !== null && oe.attachments[0].url) ? oe.attachments[0].url : /<img.*?src="(.*?)"/.exec(oe.content)[1];
    }catch(exc){}
    return e;
  };
  return new Noticias();
})


.factory('Banner', function($http){

  var banner = {AdURL:"img/default.jpg"};

  return {
    getBanner: function(){
      return this.banner;
    },
    update: function(succescb){
      this.request(succescb);
    },
    request: function(succescb)
    {
      $http({
        method:'GET',
        url:'http://ferriz.com.mx/ads.php'/*?nocache='+(new Date().getTime())*/
      })
      .success(function(data)
      {
        var _banner = data.EplanningAds.Space.Ad,
            cast = ["title","width","height","AdURL","ClickThroughURL","ClickTrackURL"];
        try{
          for(var prop in cast)
            banner[cast[prop]] = _banner[cast[prop]];
        }catch(e){}
        succescb(banner);
      })
      .error(function(){
        succescb(banner);
      });
    }
  };
})
;
